﻿using Ozeki.VoIP;
using System;
using Ozeki.Media;

namespace _05_IVR_using_XML_basic
{
    class SpeakCommand : ICommand
    {
     //   ICall _call;
        PhoneCallAudioSender _phoneCallAudioSender;
        MediaConnector _mediaConnector;
        TextToSpeech _tts;
        string _text;
        bool _isStarted;

        public SpeakCommand(string text)
        {
            _text = text;
        }

        public void Start(ICall call)
        {
            _isStarted = true;
            //_call = call;
            _phoneCallAudioSender = new PhoneCallAudioSender();
            _phoneCallAudioSender.AttachToCall(call);
            _mediaConnector = new MediaConnector();
            TextToSpeech(_text);
        }

        private void TextToSpeech(string speach)
        {
            _tts = new TextToSpeech();
            _tts.Stopped += tts_Stopped;
            _mediaConnector.Connect(_tts, _phoneCallAudioSender);
            _tts.AddAndStartText(speach);
        }

        void tts_Stopped(object sender, EventArgs e)
        {
            if (!_isStarted)
                return;
            _isStarted = false;

            var handler = Completed;
            if (handler != null)
                handler(this, EventArgs.Empty);
        }

        public void Cancel()
        {
            if (_tts != null)
            {
                _mediaConnector.Disconnect(_tts, _phoneCallAudioSender);
                _mediaConnector.Dispose();
            }
        }

        public event EventHandler Completed;
    }
}
